package com.brocade.dcm.as7.test;

import java.security.Principal;
import java.util.Map;

import org.jboss.ejb.client.EJBClientInterceptor;
import org.jboss.ejb.client.EJBClientInvocationContext;

/**
 * Client side interceptor responsible for propagating the local identity.
 * 
 * @author <a href="mailto:darran.lofthouse@jboss.com">Darran Lofthouse</a>
 */
public class ClientSecurityInterceptor implements EJBClientInterceptor {

    public void handleInvocation(EJBClientInvocationContext context) throws Exception {
        Principal currentPrincipal = SecurityActions.securityContextGetPrincipal();
        System.out.println("IN client interceptor:" + currentPrincipal);
        if (currentPrincipal != null) {
            Map<String, Object> contextData = context.getContextData();
            contextData.put("DELEGATED_USER_KEY", currentPrincipal.getName());
        }

        context.sendRequest();
    }

    public Object handleInvocationResult(EJBClientInvocationContext context) throws Exception {
        return context.getResult();
    }

}

